//-----------------------------------------------------------------------------
// AutoRepeatVolumeButtons.m
//
// Example of Repeating Buttons
// uses AutoRepeatButtons created by WillFisher
//
// modified by FrisbeeMonkey
//-----------------------------------------------------------------------------

// never forget to include std.mi
#include "c:\Program Files\Winamp3/lib/std.mi"

//Include the AutoRepeatButton Library
#include "AutoRepeatButton.m"

Function getVolumeChangeRate();

Global AutoRepeatButton VolumeUp, VolumeDown; //Define our buttons, note the use of AutoRepeatButton as opposed to just Button
Global Text SongTicker;     //Define the status text thing. In a real skin, perhaps use setTempText()
Global float CurrentVolume; 
Global Slider hidvol; 
Global Timer SongTickerTimer;

Global float CurrentVolume; //Define a volume var that is floating point, so that we can go in 2.55 (1%) jumps

System.onScriptLoaded() {
  AutoRepeat_Load();  //This must be done in all scripts using the AutoRepeatButton library

  Layout mainslim = getContainer("main").getLayout("slim");

  //now that we have the group, get the buttons in the group
  VolumeUp = mainslim.getObject("VolumeUp");
  VolumeDown = mainslim.getObject("VolumeDown");
  SongTicker = mainslim.getObject("Songticker");
  SongTickerTimer = new Timer;
  SongTickerTimer.setDelay(750);
  hidvol = mainslim.getObject("hidvol");
  CurrentVolume = System.GetVolume(); //start off out Current Volume var
}

System.onScriptUnLoading() {
  AutoRepeat_UnLoad();  //This must be done in all scripts using the AutoRepeatButton library
}

// Clears text area
SongTickerTimer.onTimer() {
  SongTicker.setText("");
  SongTickerTimer.stop();
}


System.onVolumeChanged(int newvol) {             //If we did change the volume update CurrentVolume
  if (System.Integer(CurrentVolume) != newvol) {
    CurrentVolume = Newvol;
  }
}

VolumeUp.onLeftClick() {
  if (AutoRepeat_ClickType != 0) {    CurrentVolume = CurrentVolume + getVolumeChangeRate();
    System.SetVolume(system.integer(CurrentVolume)); //set the new volume level
	SongTickerTimer.stop();
	SongTickerTimer.start();
	SongTicker.SetText("Vol: " + System.IntegertoString(CurrentVolume/8.5) + " dB"); 
 }
	if ((CurrentVolume/8.5) == 30){
		SongTickerTimer.stop();
		SongTickerTimer.start();
		SongTicker.SetText("Vol: MAX");
  }
}						


VolumeDown.onLeftClick() {  //this contains the code for clicks AND NOW autorepeats of VolumeDown
  if (AutoRepeat_ClickType != 0) {  //use this to avoid calls to this that the AutoRepeatLibrary didn't want

    /*Here goes all the code to do when the button is pressed, for now lets just decrease the volume by 1dB */

    CurrentVolume = CurrentVolume - getVolumeChangeRate(); //decrease the currentvolume by 2.55 (1%)
    System.SetVolume(system.integer(CurrentVolume)); //set the new volume level
 	SongTickerTimer.stop();
	SongTickerTimer.start();
   SongTicker.SetText("Vol: " + System.IntegertoString(CurrentVolume/8.5) + " dB"); //update the SongTicker
  }
	if ((CurrentVolume/8.5) == 0){
		SongTickerTimer.stop();
		SongTickerTimer.start();
		SongTicker.SetText("Vol: OFF");
  }
}

hidvol.onPostedPosition(int p) {
  Float f;
  f = p;
  f = f / 255 * 100;
		SongTickerTimer.stop();
		SongTickerTimer.start();
  SongTicker.SetText("Vol: " + System.integerToString(CurrentVolume/8.5) + " dB");
	if ((CurrentVolume/8.5) == 30){
		SongTickerTimer.stop();
		SongTickerTimer.start();
		SongTicker.SetText("Vol: MAX");
  }	if ((CurrentVolume/8.5) == 0){
		SongTickerTimer.stop();
		SongTickerTimer.start();
		SongTicker.SetText("Vol: OFF");
  }
}


getVolumeChangeRate() {
	return System.getPrivateInt("D-Shock", "VolumeButtonRate", 3);
}